'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var pendingJobs = [];
var jobsStatus = {
  pending: 0,
  completed: 0,
  failed: 0,
  timedOut: 0
};

var trackPendingJobs = exports.trackPendingJobs = function trackPendingJobs(jobsList) {
  jobsList.map(function (job) {

    if (!job) {
      throw new Error('trackPendingJobs expects a list of jobs');
    }

    pendingJobs.push({
      correlationId: job.correlationId,
      timestamp: new Date().getTime()
    });
  });

  jobsStatus.pending = pendingJobs.length;
};

var unTrackPendingJob = exports.unTrackPendingJob = function unTrackPendingJob(aJob) {

  pendingJobs = pendingJobs.filter(function (job) {
    return aJob.correlationId !== job.correlationId;
  });

  jobsStatus.pending = pendingJobs.length;
};

var pendingJobsCount = exports.pendingJobsCount = function pendingJobsCount() {
  return pendingJobs.length;
};

var increaseStatusCompleted = exports.increaseStatusCompleted = function increaseStatusCompleted(num) {
  jobsStatus.completed += num || 1;
};

var increaseStatusFailed = exports.increaseStatusFailed = function increaseStatusFailed(num) {
  jobsStatus.failed += num || 1;
};

var increaseStatusTimedOut = exports.increaseStatusTimedOut = function increaseStatusTimedOut(num) {
  jobsStatus.timedOut += num || 1;
};