
let pendingJobs = []
const jobsStatus = {
  pending: 0,
  completed: 0,
  failed: 0,
  timedOut: 0
}



export const trackPendingJobs = (jobsList) => {
  jobsList.map(job => {

    if (!job) {
      throw new Error('trackPendingJobs expects a list of jobs')
    }

    pendingJobs.push({
      correlationId: job.correlationId,
      timestamp: new Date().getTime()
    })

  })

  jobsStatus.pending = pendingJobs.length
}



export const unTrackPendingJob = (aJob) => {

  pendingJobs = pendingJobs.filter(job => {
    return aJob.correlationId !== job.correlationId
  })

  jobsStatus.pending = pendingJobs.length
}



export const pendingJobsCount = () => {
  return pendingJobs.length
}



export const increaseStatusCompleted = (num) => {
  jobsStatus.completed += num || 1
}



export const increaseStatusFailed = (num) => {
  jobsStatus.failed += num || 1
}



export const increaseStatusTimedOut = (num) => {
  jobsStatus.timedOut += num || 1
}

