

export class TimeoutError extends Error {
  constructor(message) {
    super(message);
    // a workaround to make `instanceof TimeoutError` work in ES5
    this.constructor = TimeoutError
    this.__proto__   = TimeoutError.prototype // eslint-disable-line no-proto
  }
}



export const promiseWithTimeout = (ms, promise) => {

  const timeout = new Promise((resolve, reject) => {
    const id = setTimeout(() => {
      clearTimeout(id);
      reject(new TimeoutError('Promise timed out in '+ ms + 'ms.'))
    }, ms)
  })

  return Promise.race([
    promise,
    timeout
  ])
}

